/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 2.2.A, Date: 16-Jun-2010.
 * Copyright (c) 2003-2018 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include <stdio.h>
#include <stdlib.h>
#include "test.h"
#include "rtxsrc/rtxStreamFile.h"
#include "rtxsrc/rtxPrint.h"
#include "rtxsrc/rtxDiag.h"

PersonnelRecord* Test_personnelRecord (OSCTXT* pctxt);

int main (int argc, char** argv)
{
   PersonnelRecord* pdata;
   OSCTXT       ctxt;
   int          i, stat;
   const char*  jsonfname = "message.json";
   OSBOOL       trace = TRUE;
   OSRTDiagTraceLevel traceLevel = OSRTDiagError;

   /* Process command line arguments */

   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!OSCRTLSTRCMP (argv[i], "-o")) jsonfname = argv[++i];
         else if (!OSCRTLSTRCMP (argv[i], "-notrace")) trace = FALSE;
         else if (!OSCRTLSTRCMP (argv[i], "-v")) traceLevel = OSRTDiagInfo;
         else if (!OSCRTLSTRCMP (argv[i], "-vv")) traceLevel = OSRTDiagDebug;
         else {
            printf ("usage: writer [options]\n");
            printf ("options:\n");
            printf ("   -v  verbose mode: print trace info\n");
            printf ("   -o <filename>  write encoded msg to <filename>\n");
            printf ("   -notrace  do not display trace info\n");
            return 0;
         }
      }
   }

   /* Init context */

   stat = rtxInitContext (&ctxt);
   if (0 != stat) {
      printf ("Context initialization failed.\n");
      rtxErrPrint (&ctxt);
      return stat;
   }
   if (traceLevel > OSRTDiagError) {
      rtxDiagSetTraceLevel (&ctxt, traceLevel);
   }

   /* Populate structure of generated type */

   pdata = Test_personnelRecord (&ctxt);

   /* Encode JSON */

   stat = rtxStreamFileCreateWriter (&ctxt, jsonfname);

   if (0 == stat) {
      stat = JsonEnc_personnelRecord (&ctxt, pdata);
   }
   rtxStreamClose (&ctxt);

   if (0 == stat) {
      if (trace) {
         printf ("encoded message:\n");
         rtxPrintFile (jsonfname);
         printf ("\n");
      }
   }
   else {
      printf ("Encoding failed\n");
      rtxErrPrint (&ctxt);
   }

   rtxFreeContext (&ctxt);

   return stat;
}

PersonnelRecord* Test_personnelRecord (OSCTXT* pctxt)
{
   PersonnelRecord* pvalue = rtxMemAllocType (pctxt, PersonnelRecord);
   Init_PersonnelRecord (pctxt, pvalue);
   pvalue->salary1 = 31415.92;
   pvalue->m.salary1Present = 1;
   pvalue->dbl1 = 3.14159;
   pvalue->m.dbl1Present = 1;
   pvalue->float1 = 3.14;
   pvalue->m.float1Present = 1;
   pvalue->en = 1E-1;
   pvalue->en2 = 0.123456;
   pvalue->salary.elem[0] = 61200.12;
   pvalue->salary.elem[1] = 0.1;
   pvalue->salary.elem[2] = 1.0;
   pvalue->salary.elem[3] = -1.0;
   pvalue->salary.elem[4] = 1700000000000.0;
   pvalue->salary.elem[5] = 0.0;
   pvalue->salary.elem[6] = 6543210.12345678;
   pvalue->salary.elem[7] = -6543210.12;
   pvalue->salary.elem[8] = 93.25;
   pvalue->salary.elem[9] = 100000000.0;
   pvalue->salary.elem[10] = 0.1;
   pvalue->salary.elem[11] = 0.01;
   pvalue->salary.elem[12] = -0.01;
   pvalue->salary.elem[13] = 0.09;
   pvalue->salary.elem[14] = 0.001;
   pvalue->salary.elem[15] = 0.0001;
   pvalue->salary.elem[16] = 0.00009;
   pvalue->salary.n = 17;
   pvalue->dbl.elem[0] = 1.23456E100;
   pvalue->dbl.elem[1] = 1.7654321E33;
   pvalue->dbl.elem[2] = rtxGetMinusZero ();
   pvalue->dbl.elem[3] = 0.0;
   pvalue->dbl.elem[4] = -1.7E33;
   pvalue->dbl.elem[5] = 1.7E-33;
   pvalue->dbl.elem[6] = 93.25;
   pvalue->dbl.elem[7] = 100000000.0;
   pvalue->dbl.elem[8] = 1E-1;
   pvalue->dbl.elem[9] = 1E-2;
   pvalue->dbl.elem[10] = -1E-2;
   pvalue->dbl.elem[11] = 9E-2;
   pvalue->dbl.elem[12] = 1E-3;
   pvalue->dbl.elem[13] = 1E-4;
   pvalue->dbl.elem[14] = 1E-5;
   pvalue->dbl.elem[15] = 9E-6;
   pvalue->dbl.n = 19;
   pvalue->m.float_Present = 1;
   pvalue->float_ = 314.159E-5;
   pvalue->dblNoExp = .000234;
   pvalue->decml = 500000000.5;
   pvalue->dblNoExp2 = 100000000.1;
   pvalue->dblNoExp3 = 100000000.1112;
   return (pvalue);
}

