/**
 * This file was generated by the Objective Systems XBinder(tm) Compiler
 * (http://www.obj-sys.com).  Version: 2.1.0, Date: 20-Apr-2010.
 * Copyright (c) 2003-2018 Objective Systems, Inc.
 *
 * Permission is hereby granted to redistribute this file with the
 * condition that this copyright notice be present and not altered.
 */
#include <stdio.h>
#include <stdlib.h>
#include "rtxsrc/rtxDiag.h"
#include "rtxsrc/rtxStreamFile.h"
#include "simpleArray.h"

int main (int argc, char** argv)
{
   SimpleArray  pdu;
   OSCTXT       ctxt;
   int          i, stat;
   OSBOOL       trace = TRUE;
   const char*  filename = "message.json";
   OSRTDiagTraceLevel traceLevel = OSRTDiagError;

   /* Process command line arguments */

   if (argc > 1) {
      for (i = 1; i < argc; i++) {
         if (!OSCRTLSTRCMP (argv[i], "-i")) filename = argv[++i];
         else if (!OSCRTLSTRCMP (argv[i], "-notrace")) trace = FALSE;
         else if (!OSCRTLSTRCMP (argv[i], "-v")) traceLevel = OSRTDiagInfo;
         else if (!OSCRTLSTRCMP (argv[i], "-vv")) traceLevel = OSRTDiagDebug;
         else {
            printf ("usage: reader [options]\n");
            printf ("options:\n");
            printf ("   -v  verbose mode: print trace info\n");
            printf ("   -i <filename>  read encoded msg from <filename>\n");
            printf ("   -notrace  do not display trace info\n");
            return 0;
         }
      }
   }

   /* Init context */

   stat = rtxInitContext (&ctxt);
   if (0 != stat) {
      printf ("Context initialization failed.\n");
      rtxErrPrint (&ctxt);
      return stat;
   }
   if (traceLevel > OSRTDiagError) {
      rtxDiagSetTraceLevel (&ctxt, traceLevel);
   }

   /* Create input source object */

   stat = rtxStreamFileCreateReader (&ctxt, filename);
   if (0 != stat) {
      printf ("Create file input stream failed.\n");
      rtxErrPrint (&ctxt);
      rtxFreeContext (&ctxt);
      return stat;
   }

   /* Init PDU data variable */
   Init_SimpleArray (&ctxt, &pdu);

   /* Call compiler generated decode function */
   if (stat == 0)
      stat = JsonDec_simpleArray (&ctxt, &pdu);

   if (stat == 0) {
      if (trace) {
         printf ("Decode was successful\n");
         printf ("Decoded record:\n");
         Print_SimpleArray ("simpleArray", &pdu);
      }
   }
   else {
      printf ("decode failed\n");
      rtxErrPrint (&ctxt);
   }

   rtxStreamClose (&ctxt);
   rtxFreeContext (&ctxt);

   return stat;
}
